--[[
BY
 _____   _____   __   _  
|  _  \ /  _  \ |  \ | | 
| | | | | | | | |   \| | 
| | | | | | | | | |\   | 
| |_| | | |_| | | | \  | 
|_____/ \_____/ |_|  \_| 

]]
local PET_BRAIN = require("brains/crittersbrain")
local PET_SG = "SGpetsdon"
require ("stategraphs/" .. PET_SG)

--GERAL:
local STR_PETTAG = "Pet"
local STR_BEFR = "Befriend a"
local WAKE_TO_FOLLOW_DISTANCE = 6
local SLEEP_NEAR_LEADER_DISTANCE = 5

local HUNGRY_PERISH_PERCENT = 0.5
local STARVING_PERISH_PERCENT = 0.2


--BABY_DOYDOY
local babydoydoyname = "Baby DoyDoy"

STRINGS.NAMES.PETDONBABYDOYDOY_BUILDER = (STR_PETTAG.." "..babydoydoyname)
STRINGS.RECIPE_DESC.PETDONBABYDOYDOY_BUILDER = (STR_BEFR.." "..babydoydoyname..".")

local babydoydoyanimzip =
{
	Asset("ANIM", "anim/doydoy_baby.zip"),
	Asset("ANIM", "anim/doydoy_baby_build.zip"),
}

local babydoydoyconfiganim = 
{
	bank = "doydoy_baby",
	build = "doydoy_baby_build",
}


local babydoydoyanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "hit", --carinho
	emote_nuzzle = "eat", --carinho 2
	emote_playful = "hit", --brincar
}

local babydoydoysounds = 
{
	walk = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_baby_jump_2", --andar
	
	sleep = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_Sleep_1", --dormir
	yell = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_baby_hit_1", --grito/carinho
	eat = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_eatpre_3", --comer
	chew = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_swallow_1", --mastigar
	hungry = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_baby_death_4", --fome
	grunt = "petdonbabydoydoysounds/petdonbabydoydoysounds/DSS_Doidoi_baby_jump_1", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--STINK_RAY
local stungrayname = "Stink Ray"

STRINGS.NAMES.PETDONSTUNGRAY_BUILDER = (STR_PETTAG.." "..stungrayname)
STRINGS.RECIPE_DESC.PETDONSTUNGRAY_BUILDER = (STR_BEFR.." "..stungrayname..".")

local stungrayanimzip =
{
	Asset("ANIM", "anim/stinkray.zip"),
}

local stungrayconfiganim = 
{
	bank = "stinkray",
	build = "stinkray",
}


local stungrayanims = 
{
	idle = "fly_loop", --parado
	hungry = "atk", --fome
	eat = "hit", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "fly_loop", --andar
	walk_pst = "fly_loop", --andar
	walk_loop = "fly_loop", --andar
	
	emote_pet = "emerge", --carinho
	emote_nuzzle = "submerge", --carinho 2
	emote_playful = "submerge", --brincar
}

local stungraysounds = 
{
	walk = "petdonstungraysounds/petdonstungraysounds/StinkRay_FLAP_09", --andar
	
	sleep = "petdonstungraysounds/petdonstungraysounds/StinkRay_Sleep_01", --dormir
	yell = "petdonstungraysounds/petdonstungraysounds/StinkRay_death_08", --grito/carinho
	eat = "petdonstungraysounds/petdonstungraysounds/StinkRay_Idle_10", --comer
	chew = "petdonstungraysounds/petdonstungraysounds/StinkRay_Idle_05", --mastigar
	hungry = "petdonstungraysounds/petdonstungraysounds/StinkRay_Taunt_06", --fome
	grunt = "petdonstungraysounds/petdonstungraysounds/StinkRay_HIT_08", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--CRABBIT
local crabbitname = "Crabbit"

STRINGS.NAMES.PETDONCRABBIT_BUILDER = (STR_PETTAG.." "..crabbitname)
STRINGS.RECIPE_DESC.PETDONCRABBIT_BUILDER = (STR_BEFR.." "..crabbitname..".")

local crabbitanimzip =
{
	Asset("ANIM", "anim/crabbit.zip"),
	Asset("ANIM", "anim/crabbit_build.zip"),
}

local crabbitconfiganim = 
{
	bank = "crabbit",
	build = "crabbit_build",
}


local crabbitanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "rabbit_eat_loop", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk", --andar
	
	emote_pet = "look", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "look", --brincar
}

local crabbitsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdoncrabbitsounds/petdoncrabbitsounds/crab_scream_short_10", --dormir
	yell = "petdoncrabbitsounds/petdoncrabbitsounds/crabbit_sandeyse_1", --grito/carinho
	eat = "petdoncrabbitsounds/petdoncrabbitsounds/crab_scream_short_05", --comer
	chew = "petdoncrabbitsounds/petdoncrabbitsounds/crab_walk_dirt_1", --mastigar
	hungry = "petdoncrabbitsounds/petdoncrabbitsounds/crab_scream_01", --fome
	grunt = "petdoncrabbitsounds/petdoncrabbitsounds/crab_scream_12", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--DOGFISH
local dogfishname = "Dogfish"

STRINGS.NAMES.PETDONDOGFISH_BUILDER = (STR_PETTAG.." "..dogfishname)
STRINGS.RECIPE_DESC.PETDONDOGFISH_BUILDER = (STR_BEFR.." "..dogfishname..".")

local dogfishanimzip =
{
	Asset("ANIM", "anim/fish_dogfish.zip"),
}

local dogfishconfiganim = 
{
	bank = "dogfish",
	build = "fish_dogfish",
}


local dogfishanims = 
{
	idle = "fishmed", --parado
	hungry = "hit", --fome
	eat = "hit", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "fishmed", --andar
	walk_pst = "fishmed", --andar
	walk_loop = "fishmed", --andar
	
	emote_pet = "hit", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "hit", --brincar
}

local dogfishsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdondogfishsounds/petdondogfishsounds/Dogfish (Solofish)_swim_idle_01", --dormir
	yell = "petdondogfishsounds/petdondogfishsounds/Dogfish (Solofish)_Emerge_06", --grito/carinho
	eat = "petdondogfishsounds/petdondogfishsounds/Dogfish (Solofish)_hit_03", --comer
	chew = "petdondogfishsounds/petdondogfishsounds/Dogfish (Solofish)_hit_05", --mastigar
	hungry = "petdondogfishsounds/petdondogfishsounds/Dogfish (Solofish)_death_02", --fome
	grunt = "petdondogfishsounds/petdondogfishsounds/Dogfish_(solofish)_SUBMERGE_01", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--FLUP
local flupname = "Flup"

STRINGS.NAMES.PETDONFLUP_BUILDER = (STR_PETTAG.." "..flupname)
STRINGS.RECIPE_DESC.PETDONFLUP_BUILDER = (STR_BEFR.." "..flupname..".")

local flupanimzip =
{
	Asset("ANIM", "anim/flup_build.zip"),
	Asset("ANIM", "anim/flup_basic.zip"),
}

local flupconfiganim = 
{
	bank = "flup",
	build = "flup_build",
}


local flupanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "eat_pre", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "jump_pre", --andar
	walk_pst = "jump_pst", --andar
	walk_loop = "look_loop2", --andar
	
	emote_pet = "jump", --carinho
	emote_nuzzle = "jump_atk", --carinho 2
	emote_playful = "jump", --brincar
}

local flupsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Sleep_01", --dormir
	yell = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Death_03", --grito/carinho
	eat = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Attack_01", --comer
	chew = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Blink_01", --mastigar
	hungry = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Hurt_07", --fome
	grunt = "petdonflupsounds/petdonflupsounds/DSS_FLUP_Swallow_03", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--PACKIM
local packimname = "Packim Baggims"

STRINGS.NAMES.PETDONPACKIM_BUILDER = (STR_PETTAG.." "..packimname)
STRINGS.RECIPE_DESC.PETDONPACKIM_BUILDER = (STR_BEFR.." "..packimname..".")

local packimanimzip =
{
	Asset("ANIM", "anim/packim.zip"),
	Asset("ANIM", "anim/packim_build.zip"),
}

local packimconfiganim = 
{
	bank = "packim",
	build = "packim_build",
}


local packimanims = 
{
	idle = "idle_loop", --parado
	hungry = "hit", --fome
	eat = "swallow", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "transform", --carinho
	emote_nuzzle = "takeoff", --carinho 2
	emote_playful = "takeoff", --brincar
}

local packimsounds = 
{
	walk = "petdonpackimsounds/petdonpackimsounds/DSS_packim_fly_02", --andar
	
	sleep = "petdonpackimsounds/petdonpackimsounds/PACKIM_Death_01", --dormir
	yell = "petdonpackimsounds/petdonpackimsounds/DSS_packim_fat_Open_01", --grito/carinho
	eat = "petdonpackimsounds/petdonpackimsounds/PACKIM_Open_1", --comer
	chew = "petdonpackimsounds/petdonpackimsounds/PACKIM_Open_11", --mastigar
	hungry = "petdonpackimsounds/petdonpackimsounds/DSS_packim_swallow_v2_5", --fome
	grunt = "petdonpackimsounds/petdonpackimsounds/DSS_packim_fat_hit_08", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--SHARKITTEN
local sharkittenname = "Sharkitten"

STRINGS.NAMES.PETDONSHARKITTEN_BUILDER = (STR_PETTAG.." "..sharkittenname)
STRINGS.RECIPE_DESC.PETDONSHARKITTEN_BUILDER = (STR_BEFR.." "..sharkittenname..".")

local sharkittenanimzip =
{
    Asset("ANIM", "anim/sharkitten_basic.zip"),
	Asset("ANIM", "anim/sharkitten_build.zip"),
}

local sharkittenconfiganim = 
{
	bank = "sharkitten",
	build = "sharkitten_build",
}


local sharkittenanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "eat_pre", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "taunt", --carinho
	emote_nuzzle = "atk_pre", --carinho 2
	emote_playful = "atk", --brincar
}

local sharkittensounds = 
{
	walk = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_walk_Bounce_01", --andar
	
	sleep = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_death_A_1", --dormir
	yell = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_taunt_01", --grito/carinho
	eat = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_walk_voice_01", --comer
	chew = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_attack_bite_01", --mastigar
	hungry = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_attack_bite_01", --fome
	grunt = "petdonsharkittensounds/petdonsharkittensounds/DSS_tiger_kitten_walk_voice_05", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--SWORDFISH
local swordfishname = "Swordfish"

STRINGS.NAMES.PETDONSWORDFISH_BUILDER = (STR_PETTAG.." "..swordfishname)
STRINGS.RECIPE_DESC.PETDONSWORDFISH_BUILDER = (STR_BEFR.." "..swordfishname..".")

local swordfishanimzip =
{
	Asset("ANIM", "anim/fish_dogfish.zip"),
    Asset("ANIM", "anim/fish_swordfish01.zip"),
    Asset("ANIM", "anim/fish_med01.zip"),
	Asset("ANIM", "anim/fish_swordfish.zip"),
}

local swordfishconfiganim = 
{
	bank = "swordfish",
	build = "fish_swordfish",
}


local swordfishanims = 
{
	idle = "fishmed", --parado
	hungry = "hit", --fome
	eat = "hit", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "fishmed", --andar
	walk_pst = "fishmed", --andar
	walk_loop = "fishmed", --andar
	
	emote_pet = "hit", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "hit", --brincar
}

local swordfishsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_death_1", --dormir
	yell = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_hit_01", --grito/carinho
	eat = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_attack_1", --comer
	chew = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_attack_pre_01", --mastigar
	hungry = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_sword_1", --fome
	grunt = "petdonswordfishsounds/petdonswordfishsounds/DSS_swordfish_hit_05", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--SHARX
local sharxname = "Sea Hound"

STRINGS.NAMES.PETDONSHARX_BUILDER = (STR_PETTAG.." "..sharxname)
STRINGS.RECIPE_DESC.PETDONSHARX_BUILDER = (STR_BEFR.." "..sharxname..".")

local sharxanimzip =
{
    Asset("ANIM", "anim/sharx.zip"),
	Asset("ANIM", "anim/sharx_build.zip"),
}

local sharxconfiganim = 
{
	bank = "sharx",
	build = "sharx_build",
}


local sharxanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "atk", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "run_loop", --andar
	walk_pst = "run_loop", --andar
	walk_loop = "run_loop", --andar
	
	emote_pet = "submerge", --carinho
	emote_nuzzle = "emerge", --carinho 2
	emote_playful = "taunt", --brincar
}

local sharxsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdonsharxsounds/petdonsharxsounds/DSS_sharx_sleep_1", --dormir
	yell = "petdonsharxsounds/petdonsharxsounds/DSS_sharx_taunt_V3_02", --grito/carinho
	eat = "petdonsharxsounds/petdonsharxsounds/DSS_Sharx_attack_v2_07", --comer
	chew = "petdonsharxsounds/petdonsharxsounds/DSS_Sharx_hit_v2_2", --mastigar
	hungry = "petdonsharxsounds/petdonsharxsounds/DSS_Sharx_death_v2_5", --fome
	grunt = "petdonsharxsounds/petdonsharxsounds/DSS_Sharx_panting_v2_8", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--PRIMEAPE
local primeapename = "Prime Ape"

STRINGS.NAMES.PETDONPRIMEAPE_BUILDER = (STR_PETTAG.." "..primeapename)
STRINGS.RECIPE_DESC.PETDONPRIMEAPE_BUILDER = (STR_BEFR.." "..primeapename..".")

local primeapeanimzip =
{
	Asset("ANIM", "anim/kiki_basic_sw.zip"),
	Asset("ANIM", "anim/junglekiki_build.zip"),	
}

local primeapeconfiganim = 
{
	bank = "kiki",
	build = "junglekiki_build",
}


local primeapeanims = 
{
	idle = "idle_loop", --parado
	hungry = "throw", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	--emote_pet = "befriend", --carinho
	emote_pet = "interact", --carinho
	emote_nuzzle = "interact", --carinho 2
	emote_playful = "interact", --brincar
}

local primeapesounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "petdonprimeapesounds/petdonprimeapesounds/kiki_sleep_1", --dormir
	yell = "petdonprimeapesounds/petdonprimeapesounds/kiki_roar_1", --grito/carinho
	eat = "petdonprimeapesounds/petdonprimeapesounds/kiki_eat_6", --comer
	chew = "petdonprimeapesounds/petdonprimeapesounds/kiki_eat_1", --mastigar
	hungry = "petdonprimeapesounds/petdonprimeapesounds/kiki_die_1", --fome
	grunt = "petdonprimeapesounds/petdonprimeapesounds/kiki_roar_5", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--PIRATEGHOST
local pirateghostname = "Pirate Ghost"

STRINGS.NAMES.PETDONPIRATEGHOST_BUILDER = (STR_PETTAG.." "..pirateghostname)
STRINGS.RECIPE_DESC.PETDONPIRATEGHOST_BUILDER = (STR_BEFR.." "..pirateghostname..".")

local pirateghostanimzip =
{
	Asset("ANIM", "anim/ghost_pirate.zip"),
}

local pirateghostconfiganim = 
{
	bank = "ghost",
	build = "ghost_pirate_build",
}

local pirateghostanims = 
{
	idle = "idle", --parado
	hungry = "angry", --fome
	eat = "angry", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "idle", --andar
	walk_pst = "idle", --andar
	walk_loop = "idle", --andar
	
	emote_pet = "appear", --carinho
	emote_nuzzle = "dissipate", --carinho 2
	emote_playful = "appear", --brincar
}

local pirateghostsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "dontstarve/ghost/ghost_howl", --dormir
	yell = "dontstarve/ghost/ghost_howl", --grito/carinho
	eat = "dontstarve/ghost/ghost_howl", --comer
	chew = "dontstarve/ghost/ghost_howl", --mastigar
	hungry = "dontstarve/ghost/ghost_howl", --fome
	grunt = "dontstarve/ghost/ghost_howl", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--V0.2:


--MOSSLING
local mosslingname = "Mosling"

STRINGS.NAMES.PETDONMOSSLING_BUILDER = (STR_PETTAG.." "..mosslingname)
STRINGS.RECIPE_DESC.PETDONMOSSLING_BUILDER = (STR_BEFR.." "..mosslingname..".")

local mosslinganimzip =
{
	Asset("ANIM", "anim/mossling_build.zip"),
    Asset("ANIM", "anim/mossling_basic.zip"),
    Asset("ANIM", "anim/mossling_actions.zip"),
    Asset("ANIM", "anim/mossling_angry_build.zip"),
}

local mosslingconfiganim = 
{
	bank = "mossling",
	build = "mossling_build",
}

local mosslinganims = 
{
	idle = "idle", --parado
	hungry = "atk", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "hatch", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "eat_pst", --brincar
}

local mosslingsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "dontstarve_DLC001/creatures/mossling/sleep", --dormir
	yell = "dontstarve_DLC001/creatures/mossling/hatch", --grito/carinho
	eat = "dontstarve_DLC001/creatures/mossling/eat", --comer
	chew = "dontstarve_DLC001/creatures/mossling/chew", --mastigar
	hungry = "dontstarve_DLC001/creatures/mossling/hurt", --fome
	grunt = "dontstarve_DLC001/creatures/mossling/yawn", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------


--PENGUIN 
local penguinname = "Pengull"

STRINGS.NAMES.PETDONPENGUIN_BUILDER = (STR_PETTAG.." "..penguinname)
STRINGS.RECIPE_DESC.PETDONPENGUIN_BUILDER = (STR_BEFR.." "..penguinname..".")

local penguinanimzip =
{
    Asset("ANIM", "anim/penguin.zip"),
    Asset("ANIM", "anim/penguin_build.zip"),
}

local penguinconfiganim = 
{
	bank = "penguin",
	build = "penguin_build",
}

local penguinanims = 
{
	idle = "idle_loop", --parado
	hungry = "hit", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "slide_bounce", --andar
	walk_pst = "slide_post", --andar
	walk_loop = "slide_loop", --andar
	
	emote_pet = "taunt", --carinho
	emote_nuzzle = "taunt", --carinho 2
	emote_playful = "atk", --brincar
}

local penguinsounds = 
{
	walk = "dontstarve/creatures/pengull/footstep", --andar
	--walk = "dontstarve/creatures/pengull/slide", --andar
	
	sleep = "dontstarve/creatures/pengull/sleep", --dormir
	yell = "dontstarve/creatures/pengull/taunt", --grito/carinho
	eat = "dontstarve/creatures/pengull/idle", --comer
	chew = "dontstarve/creatures/pengull/idle", --mastigar
	hungry = "dontstarve/creatures/pengull/attack", --fome
	grunt = "dontstarve/creatures/pengull/taunt", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--LIGHTNINGGOAT 
local lightninggoatname = "Volt Goat"

STRINGS.NAMES.PETDONLIGHTNINGGOAT_BUILDER = (STR_PETTAG.." "..lightninggoatname)
STRINGS.RECIPE_DESC.PETDONLIGHTNINGGOAT_BUILDER = (STR_BEFR.." "..lightninggoatname..".")

local lightninggoatanimzip =
{
    Asset("ANIM", "anim/lightning_goat_build.zip"),
    Asset("ANIM", "anim/lightning_goat_shocked_build.zip"),
    Asset("ANIM", "anim/lightning_goat_basic.zip"),
    Asset("ANIM", "anim/lightning_goat_actions.zip"),
}

local lightninggoatconfiganim = 
{
	bank = "lightning_goat",
	build = "lightning_goat_build",
}

local lightninggoatanims = 
{
	idle = "idle_loop", --parado
	hungry = "taunt", --fome
	eat = "atk", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk", --andar
	
	emote_pet = "shock", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "trans", --brincar
}

local lightninggoatsounds = 
{
	walk = "dontstarve_DLC001/creatures/lightninggoat/jump", --andar
	
	sleep = "dontstarve_DLC001/creatures/lightninggoat/sleep", --dormir
	yell = "dontstarve_DLC001/creatures/lightninggoat/shocked_electric", --grito/carinho
	eat = "dontstarve_DLC001/creatures/lightninggoat/chew", --comer
	chew = "dontstarve_DLC001/creatures/lightninggoat/chew", --mastigar
	hungry = "petdonlightninggoatsounds/petdonlightninggoatsounds/", --fome
	grunt = "dontstarve_DLC001/creatures/lightninggoat/jacobshorn", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--DEER 
local deername = "No-Eyed Deer"

STRINGS.NAMES.PETDONDEER_BUILDER = (STR_PETTAG.." "..deername)
STRINGS.RECIPE_DESC.PETDONDEER_BUILDER = (STR_BEFR.." "..deername..".")

local deeranimzip =
{
    Asset("ANIM", "anim/deer_build.zip"),
    Asset("ANIM", "anim/deer_basic.zip"),
    Asset("ANIM", "anim/deer_action.zip"),
}

local deerconfiganim = 
{
	bank = "deer",
	build = "deer_build",
}

local deeranims = 
{
	idle = "idle_loop", --parado
	hungry = "taunt", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "dig", --carinho
	emote_nuzzle = "unshackle", --carinho 2
	emote_playful = "unshackle", --brincar
}

local deersounds = 
{
	walk = "dontstarve/creatures/together/deer/footstep", --andar
	
	sleep = "dontstarve/creatures/together/deer/huff", --dormir
	yell = "dontstarve/creatures/together/deer/curious", --grito/carinho
	eat = "dontstarve/creatures/together/deer/eat", --comer
	chew = "dontstarve/creatures/together/deer/huff", --mastigar
	hungry = "dontstarve/creatures/together/deer/grrr", --fome
	grunt = "dontstarve/creatures/together/deer/huff", --grunhido
	
	bodyfall = "dontstarve/creatures/together/deer/bodyfall", --cair
}
----------------------

--BAT 
local batname = "Batilisk"

STRINGS.NAMES.PETDONBAT_BUILDER = (STR_PETTAG.." "..batname)
STRINGS.RECIPE_DESC.PETDONBAT_BUILDER = (STR_BEFR.." "..batname..".")

local batanimzip =
{
	Asset("ANIM", "anim/bat_basic.zip"),
}

local batconfiganim = 
{
	bank = "bat",
	build = "bat_basic",
}

local batanims = 
{
	idle = "fly_loop", --parado
	hungry = "atk", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "fly_loop", --andar
	walk_pst = "fly_loop", --andar
	walk_loop = "fly_loop", --andar
	
	emote_pet = "taunt", --carinho
	emote_nuzzle = "taunt", --carinho 2
	emote_playful = "taunt", --brincar
}

local batsounds = 
{
	walk = "dontstarve/creatures/bat/flap", --andar
	
	sleep = "dontstarve/creatures/bat/sleep", --dormir
	yell = "dontstarve/creatures/bat/taunt", --grito/carinho
	eat = "dontstarve/creatures/bat/bite", --comer
	chew = "dontstarve/creatures/bat/chew", --mastigar
	hungry = "dontstarve/creatures/bat/hurt", --fome
	grunt = "dontstarve/creatures/bat/hurt", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--SPIDER 
local spidername = "Spider"

STRINGS.NAMES.PETDONSPIDER_BUILDER = (STR_PETTAG.." "..spidername)
STRINGS.RECIPE_DESC.PETDONSPIDER_BUILDER = (STR_BEFR.." "..spidername..".")

local spideranimzip =
{
    Asset("ANIM", "anim/ds_spider_basic.zip"),
    Asset("ANIM", "anim/spider_build.zip"),
}

local spiderconfiganim = 
{
	bank = "spider",
	build = "spider_build",
}

local spideranims = 
{
	idle = "idle", --parado
	hungry = "atk", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "taunt", --carinho
	emote_nuzzle = "taunt", --carinho 2
	emote_playful = "crap", --brincar
}

local spidersounds = 
{
	walk = "dontstarve/creatures/spider/walk_spider", --andar
	
	sleep = "dontstarve/creatures/spider/sleeping", --dormir
	yell = "dontstarve/creatures/spider/scream", --grito/carinho
	eat = "dontstarve/creatures/spider/Attack", --comer
	chew = "dontstarve/creatures/spider/attack_grunt", --mastigar
	hungry = "dontstarve/creatures/spider/scream", --fome
	grunt = "dontstarve/creatures/spider/wakeUp", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--BEE 
local beename = "Bee"

STRINGS.NAMES.PETDONBEE_BUILDER = (STR_PETTAG.." "..beename)
STRINGS.RECIPE_DESC.PETDONBEE_BUILDER = (STR_BEFR.." "..beename..".")

local beeanimzip =
{
    Asset("ANIM", "anim/bee.zip"),
    Asset("ANIM", "anim/bee_build.zip"),
    Asset("ANIM", "anim/bee_angry_build.zip"),
}

local beeconfiganim = 
{
	bank = "bee",
	build = "bee_build",
}

local beeanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "atk", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "evade", --carinho
	emote_nuzzle = "evade", --carinho 2
	emote_playful = "evade", --brincar
}

local beesounds = 
{
	--walk = "dontstarve/bee/bee_fly_LP", --andar
	walk = "petdonsounds/petdonsounds/bee_fly", --andar
	
	sleep = "dontstarve_DLC001/creatures/together/glomling/sleep_voice", --dormir
	yell = "dontstarve/bee/bee_hurt", --grito/carinho
	eat = "dontstarve/bee/bee_hurt", --comer
	chew = "dontstarve/bee/bee_hurt", --mastigar
	hungry = "dontstarve/bee/bee_death", --fome
	grunt = "dontstarve/bee/bee_tired_LP", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------


--MOSQUITO 
local mosquitoname = "Mosquito"

STRINGS.NAMES.PETDONMOSQUITO_BUILDER = (STR_PETTAG.." "..mosquitoname)
STRINGS.RECIPE_DESC.PETDONMOSQUITO_BUILDER = (STR_BEFR.." "..mosquitoname..".")

local mosquitoanimzip =
{
	Asset("ANIM", "anim/mosquito.zip"),
}

local mosquitoconfiganim = 
{
	bank = "mosquito",
	build = "mosquito",
}

local mosquitoanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "atk", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "explode", --carinho
	emote_nuzzle = "evade", --carinho 2
	emote_playful = "evade", --brincar
}

local mosquitosounds = 
{
	--walk = "dontstarve/creatures/mosquito/mosquito_fly_LP", --andar
	walk = "petdonsounds/petdonsounds/mosquito_fly", --andar
	
	sleep = "dontstarve_DLC001/creatures/together/glomling/sleep_voice", --dormir
	yell = "dontstarve/creatures/mosquito/mosquito_explo", --grito/carinho
	eat = "dontstarve/creatures/mosquito/mosquito_hurt", --comer
	chew = "dontstarve/creatures/mosquito/mosquito_attack", --mastigar
	hungry = "dontstarve/creatures/mosquito/mosquito_death", --fome
	grunt = "dontstarve/creatures/mosquito/mosquito_attack", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--MINIWILSON 
local miniwilsonname = "Mini Wilson"

STRINGS.NAMES.PETDONMINIWILSON_BUILDER = (STR_PETTAG.." "..miniwilsonname)
STRINGS.RECIPE_DESC.PETDONMINIWILSON_BUILDER = (STR_BEFR.." "..miniwilsonname..".")

local miniwilsonanimzip =
{
	Asset("ANIM", "anim/player_basic.zip"),
	Asset("ANIM", "anim/player_actions.zip"),
	Asset("ANIM", "anim/player_actions_eat.zip"),
	Asset("ANIM", "anim/player_attacks.zip"),
	Asset("ANIM", "anim/player_idles.zip"),
	Asset("ANIM", "anim/player_jump.zip"),
	Asset("ANIM", "anim/player_emotesxl.zip"),
	Asset("ANIM", "anim/player_emotes_dance0.zip"),
	Asset("ANIM", "anim/player_emotes_sit.zip"),
	Asset("ANIM", "anim/player_emotes.zip"),
}

local miniwilsonconfiganim = 
{
	bank = "wilson",
	build = "wilson",
}

local miniwilsonanims = 
{
	idle = "idle_loop", --parado
	hungry = "hungry", --fome
	eat = "eat", --comer
	sleep_pre = "dozy", --dormir
	sleep_pst = "wakeup", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "run_pre", --andar
	walk_pst = "run_pst", --andar
	walk_loop = "run_loop", --andar

	
	emote_pet = "emoteXL_loop_dance0", --carinho
	emote_nuzzle = "emote_waving", --carinho 2
	emote_playful = "emote_happycheer", --brincar
}

local miniwilsonsounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	--sleep = "dontstarve/wilson/use_bedroll", --dormir
	sleep = "dontstarve/creatures/together/perdling/sleep_in", --dormir
	yell = "dontstarve/characters/wilson/emote", --grito/carinho
	eat = "dontstarve/wilson/eat", --comer
	chew = "dontstarve/wilson/eat", --mastigar
	hungry = "dontstarve/wilson/hungry", --fome
	grunt = "dontstarve/wilson/hit", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------


--V0.3:

--BIRCHNUTDRAKE 
local birchnutdrakename = "Birchnutter"

STRINGS.NAMES.PETDONBIRCHNUTDRAKE_BUILDER = (STR_PETTAG.." "..birchnutdrakename)
STRINGS.RECIPE_DESC.PETDONBIRCHNUTDRAKE_BUILDER = (STR_BEFR.." "..birchnutdrakename..".")

local birchnutdrakeanimzip =
{
    Asset("ANIM", "anim/treedrake.zip"),
    Asset("ANIM", "anim/treedrake_build.zip"),
}

local birchnutdrakeconfiganim = 
{
	bank = "treedrake",
	build = "treedrake_build",
}

local birchnutdrakeanims = 
{
	idle = "idle_loop", --parado
	hungry = "hit", --fome
	eat = "atk", --comer
	sleep_pre = "ground_enter", --dormir
	sleep_pst = "walk_pre", --dormir
	sleep_loop = "ground_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "taunt", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "taunt", --brincar
}

local birchnutdrakesounds = 
{
	walk = "dontstarve_DLC001/creatures/deciduous/drake_run_voice", --andar
	
	sleep = "dontstarve/creatures/together/perdling/sleep_in", --dormir
	yell = "dontstarve_DLC001/creatures/deciduous/drake_attack", --grito/carinho
	eat = "dontstarve_DLC001/creatures/deciduous/drake_attack", --comer
	chew = "dontstarve_DLC001/creatures/deciduous/drake_attack", --mastigar
	hungry = "dontstarve_DLC001/creatures/deciduous/drake_die", --fome
	grunt = "dontstarve_DLC001/creatures/deciduous/drake_hit", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--MANDRAKE 
local mandrakename = "Mandrake"

STRINGS.NAMES.PETDONMANDRAKE_BUILDER = (STR_PETTAG.." "..mandrakename)
STRINGS.RECIPE_DESC.PETDONMANDRAKE_BUILDER = (STR_BEFR.." "..mandrakename..".")

local mandrakeanimzip =
{
	Asset("ANIM", "anim/mandrake.zip"),
}

local mandrakeconfiganim = 
{
	bank = "mandrake",
	build = "mandrake",
}

local mandrakeanims = 
{
	idle = "idle_loop", --parado
	hungry = "hit", --fome
	eat = "hit", --comer
	sleep_pre = "plant", --dormir
	sleep_pst = "walk_pre", --dormir
	sleep_loop = "ground", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "plant", --carinho
	emote_nuzzle = "hit", --carinho 2
	emote_playful = "plant", --brincar
}

local mandrakesounds = 
{
	walk = "dontstarve/creatures/mandrake/walk", --andar
	
	sleep = "dontstarve/creatures/together/perdling/sleep_in", --dormir
	yell = "dontstarve/creatures/mandrake/plant", --grito/carinho
	eat = "dontstarve/creatures/mandrake/pullout", --comer
	chew = "dontstarve/creatures/mandrake/hit", --mastigar
	hungry = "dontstarve/creatures/mandrake/hit", --fome
	grunt = "dontstarve/creatures/mandrake/plant", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--BUNNYMAN 
local bunnymanname = "Bunnyman"

STRINGS.NAMES.PETDONBUNNYMAN_BUILDER = (STR_PETTAG.." "..bunnymanname)
STRINGS.RECIPE_DESC.PETDONBUNNYMAN_BUILDER = (STR_BEFR.." "..bunnymanname..".")

local bunnymananimzip =
{
    Asset("ANIM", "anim/manrabbit_basic.zip"),
    Asset("ANIM", "anim/manrabbit_actions.zip"),
    Asset("ANIM", "anim/manrabbit_attacks.zip"),
    Asset("ANIM", "anim/manrabbit_build.zip"),
}

local bunnymanconfiganim = 
{
	bank = "manrabbit",
	build = "manrabbit_build",
}

local bunnymananims = 
{
	idle = "idle_loop", --parado
	hungry = "hungry", --fome
	eat = "eat", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "idle_happy", --carinho
	emote_nuzzle = "idle_happy", --carinho 2
	emote_playful = "pig_pickup", --brincar
}

local bunnymansounds = 
{
	walk = "dontstarve/creatures/bunnyman/hop", --andar
	
	sleep = "dontstarve/creatures/bunnyman/sleep", --dormir
	yell = "dontstarve/creatures/bunnyman/happy", --grito/carinho
	eat = "dontstarve/creatures/bunnyman/eat", --comer
	chew = "dontstarve/creatures/bunnyman/hurt", --mastigar
	hungry = "dontstarve/creatures/bunnyman/attack", --fome
	grunt = "dontstarve/creatures/bunnyman/bite", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--BEEGUARD 
local beeguardname = "Grumble Bee"

STRINGS.NAMES.PETDONBEEGUARD_BUILDER = (STR_PETTAG.." "..beeguardname)
STRINGS.RECIPE_DESC.PETDONBEEGUARD_BUILDER = (STR_BEFR.." "..beeguardname..".")

local beeguardanimzip =
{
    Asset("ANIM", "anim/bee_guard.zip"),
    Asset("ANIM", "anim/bee_guard_build.zip"),
    Asset("ANIM", "anim/bee_guard_puffy_build.zip"),
}

local beeguardconfiganim = 
{
	bank = "bee_guard",
	build = "bee_guard_puffy_build",
}

local beeguardanims = 
{
	idle = "idle", --parado
	hungry = "hit", --fome
	eat = "atk", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "evade", --carinho
	emote_nuzzle = "evade", --carinho 2
	emote_playful = "evade", --brincar
}

local beeguardsounds = 
{
	walk = "petdonsounds/petdonsounds/bee_fly", --andar
	
	sleep = "dontstarve_DLC001/creatures/together/glomling/sleep_voice", --dormir
	yell = "dontstarve/creatures/together/bee_queen/beeguard/hurt", --grito/carinho
	eat = "dontstarve/creatures/together/bee_queen/beeguard/hurt", --comer
	chew = "dontstarve/creatures/together/bee_queen/beeguard/hurt", --mastigar
	hungry = "dontstarve/creatures/together/bee_queen/beeguard/death", --fome
	grunt = "dontstarve/bee/bee_tired_LP", --grunhido
	
	bodyfall = "dontstarve/creatures/together/sheepington/bodyfall", --cair
}
----------------------

--GRASSGEKKO 
local grassgekkoname = "Grass Gekko"

STRINGS.NAMES.PETDONGRASSGEKKO_BUILDER = (STR_PETTAG.." "..grassgekkoname)
STRINGS.RECIPE_DESC.PETDONGRASSGEKKO_BUILDER = (STR_BEFR.." "..grassgekkoname..".")

local grassgekkoanimzip =
{
	Asset("ANIM", "anim/grassgecko.zip"),
}

local grassgekkoconfiganim = 
{
	bank = "grassgecko",
	build = "grassgecko",
}

local grassgekkoanims = 
{
	idle = "idle_loop", --parado
	hungry = "hit", --fome
	eat = "tail_regrow", --comer
	sleep_pre = "sleep_pre", --dormir
	sleep_pst = "sleep_pst", --dormir
	sleep_loop = "sleep_loop", --dormir
	walk_pre = "walk_pre", --andar
	walk_pst = "walk_pst", --andar
	walk_loop = "walk_loop", --andar
	
	emote_pet = "gecko_pop", --carinho
	emote_nuzzle = "gecko_pop", --carinho 2
	emote_playful = "gecko_pop", --brincar
}

local grassgekkosounds = 
{
	walk = "dontstarve/creatures/together/sheepington/walk", --andar
	
	sleep = "dontstarve/creatures/together/grass_gekko/sleep", --dormir
	yell = "dontstarve/creatures/together/grass_gekko/tail_off", --grito/carinho
	eat = "dontstarve/wilson/pickup_reeds", --comer
	chew = "dontstarve/wilson/pickup_reeds", --mastigar
	hungry = "dontstarve/creatures/together/grass_gekko/emerge", --fome
	grunt = "dontstarve/creatures/together/grass_gekko/tail_off", --grunhido
	
	bodyfall = "dontstarve/creatures/together/grass_gekko/body_fall", --cair
}
----------------------






local function IsLeaderSleeping(inst)
    return inst.components.follower.leader and inst.components.follower.leader:HasTag("sleeping")
end

local function ShouldWakeUp(inst)
    return (DefaultWakeTest(inst) and not IsLeaderSleeping(inst)) or not inst.components.follower:IsNearLeader(WAKE_TO_FOLLOW_DISTANCE)
end

local function ShouldSleep(inst)
    return (DefaultSleepTest(inst) 
            or IsLeaderSleeping(inst))
            and inst.components.follower:IsNearLeader(SLEEP_NEAR_LEADER_DISTANCE)
end

local function oneat(inst, food)
	local perish = inst.components.perishable:GetPercent()
	local is_wellfed = inst.components.crittertraits:IsDominantTrait("wellfed")
	if perish <= STARVING_PERISH_PERCENT then
		inst.components.perishable.perishtime = math.max(inst.components.perishable.perishtime - TUNING.CRITTER_HUNGERTIME_DELTA, is_wellfed and TUNING.CRITTER_DOMINANTTRAIT_HUNGERTIME_MIN or TUNING.CRITTER_HUNGERTIME_MIN)
	elseif perish <= HUNGRY_PERISH_PERCENT then
		inst.components.perishable.perishtime = math.min(inst.components.perishable.perishtime + TUNING.CRITTER_HUNGERTIME_DELTA, is_wellfed and TUNING.CRITTER_DOMINANTTRAIT_HUNGERTIME_MAX or TUNING.CRITTER_HUNGERTIME_MAX)
	else
		if is_wellfed and inst.components.perishable.perishtime < TUNING.CRITTER_DOMINANTTRAIT_HUNGERTIME_MIN then
			inst.components.perishable.perishtime = TUNING.CRITTER_DOMINANTTRAIT_HUNGERTIME_MIN
		end
	end
	
    inst.components.perishable:SetPercent(1)
    inst.components.perishable:StartPerishing()
	
	if food ~= nil then
		if inst.favoritefood == food.prefab then
			inst.isfavoritefood = 1
		else
			inst.isfavoritefood = 0
		end
	end
	
end

-------------------------------------------------------------------------------
local function GetPeepChance(inst)
    local hunger_percent = inst.components.perishable:GetPercent()
    if hunger_percent <= 0 then
        return 0.8
    elseif hunger_percent < STARVING_PERISH_PERCENT then -- matches spoiled tag
        return (0.2 - inst.components.perishable:GetPercent()) * 2
    elseif hunger_percent < HUNGRY_PERISH_PERCENT then
        return 0.025
    end

    return 0
end

local function IsAffectionate(inst)
    return (inst.components.perishable == nil or inst.components.perishable:GetPercent() > STARVING_PERISH_PERCENT)
            or false
end

local function IsPlayful(inst)
	return IsAffectionate(inst)
end

local function IsSuperCute(inst)
	return true
end

-------------------------------------------------------------------------------

local function OnSave(inst, data)
    if inst.wormlight ~= nil then
        data.wormlight = inst.wormlight:GetSaveRecord()
    end
end

local function OnLoad(inst, data)
    if data ~= nil and data.wormlight ~= nil and inst.wormlight == nil then
        local wormlight = SpawnSaveRecord(data.wormlight)
        if wormlight ~= nil and wormlight.components.spell ~= nil then
            wormlight.components.spell:SetTarget(inst)
            if wormlight:IsValid() then
                if wormlight.components.spell.target == nil then
                    wormlight:Remove()
                else
                    wormlight.components.spell:ResumeSpell()
                end
            end
        end
    end
end

-------------------------------------------------------------------------------

local function MakeDonPet(name, petname, face, gwalktype, petscale, diet, flying, animszip, configanim, petanims, petsounds, data)

    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()
        inst.entity:AddAnimState()
        inst.entity:AddSoundEmitter()
        inst.entity:AddDynamicShadow()
        inst.entity:AddNetwork()

        inst.DynamicShadow:SetSize(2, .75)
		
		if name == "petdonpirateghost" then
			inst.AnimState:SetBloomEffectHandle("shaders/anim_bloom_ghost.ksh")
			inst.AnimState:SetLightOverride(TUNING.GHOST_LIGHT_OVERRIDE)

			inst.entity:AddLight()
			inst.Light:SetIntensity(.3)
			inst.Light:SetRadius(.2)
			inst.Light:SetFalloff(.6)
			inst.Light:Enable(true)
			inst.Light:SetColour(180/255, 195/255, 225/255)
			inst.AnimState:SetMultColour(1,1,1,.6)	
		end
		
		if name == "petdondeer" then
			inst.AnimState:Hide("swap_antler")
			inst.AnimState:Hide("CHAIN")
			inst.AnimState:OverrideSymbol("swap_neck_collar", "deer_build", "swap_neck")
		end
		
		if name == "petdonminiwilson" then
			inst.AnimState:Hide("ARM_carry")
			inst.AnimState:Hide("HAT")
			inst.AnimState:Hide("HAIR_HAT")
			inst.AnimState:Show("HAIR_NOHAT")
			inst.AnimState:Show("HAIR")
			inst.AnimState:Show("HEAD")
			inst.AnimState:Hide("HEAD_HAT")
		end
		
		if name == "petdonmosquito" then
			inst.AnimState:Show("body_1")
			inst.AnimState:Hide("body_2")
			inst.AnimState:Hide("body_3")
			inst.AnimState:Hide("body_4")
		end
				
		inst.animsdon = petanims
		inst.soundsdon = petsounds

        if face == 0 then
            inst.Transform:SetNoFaced()
        elseif face == 2 then
			inst.Transform:SetTwoFaced()
        elseif face == 4 then
            inst.Transform:SetFourFaced()
        elseif face == 6 then
            inst.Transform:SetSixFaced()
        elseif face == 8 then
            inst.Transform:SetEightFaced()
        end

        inst.AnimState:SetBank(configanim.bank)
        inst.AnimState:SetBuild(configanim.build)
        inst.AnimState:PlayAnimation(inst.animsdon.idle)

        if flying then
            inst.entity:AddPhysics()
            inst.Physics:SetMass(1)
            inst.Physics:SetFriction(0)
            inst.Physics:SetDamping(5)
            inst.Physics:SetCollisionGroup(COLLISION.CHARACTERS)
            inst.Physics:ClearCollisionMask()
            inst.Physics:CollidesWith(COLLISION.WORLD)
            inst.Physics:CollidesWith(COLLISION.FLYERS)
            inst.Physics:CollidesWith(COLLISION.CHARACTERS)
            inst.Physics:SetCapsule(.5, 1)

            inst:AddTag("flying")
        else
            MakeCharacterPhysics(inst, 1, .5)
        end

		inst.Physics:SetDontRemoveOnSleep(true)

        inst:AddTag("critter")
        inst:AddTag("companion")
        inst:AddTag("notraptrigger")
        inst:AddTag("noauradamage")
        inst:AddTag("small_livestock")
        inst:AddTag("NOBLOCK")

        if data ~= nil and data.flyingsoundloop ~= nil then
            inst.SoundEmitter:PlaySound(data.flyingsoundloop, "flying")
        end
		
		if petscale > 0 then
			inst.Transform:SetScale(petscale, petscale, petscale)
		end

        inst:AddComponent("spawnfader")

        inst.entity:SetPristine()

        if not TheWorld.ismastersim then
            return inst
        end

		inst.favoritefood = data.favoritefood

        inst.GetPeepChance = GetPeepChance
        inst.IsAffectionate = IsAffectionate
        inst.IsSuperCute = IsSuperCute
        inst.IsPlayful = IsPlayful
        
		inst.playmatetags = {"critter"}
		if data ~= nil and data.playmatetags ~= nil then
			inst.playmatetags = JoinArrays(inst.playmatetags, data.playmatetags)
		end
	
        inst:AddComponent("inspectable")

		inst:AddComponent("named")
		inst.components.named:SetName(petname)

        inst:AddComponent("follower")
        inst.components.follower:KeepLeaderOnAttacked()
        inst.components.follower.keepdeadleader = true

        inst:AddComponent("knownlocations")

        inst:AddComponent("sleeper")
        inst.components.sleeper:SetResistance(3)
        inst.components.sleeper.testperiod = GetRandomWithVariance(6, 2)
        inst.components.sleeper:SetSleepTest(ShouldSleep)
        inst.components.sleeper:SetWakeTest(ShouldWakeUp)

		local isfavoritefood = 0
		inst.isfavoritefood = 0		
		
		local walktype = "walk"
		inst.walktype = gwalktype
		
		local checkpetdonsize = petscale
		inst.checkpetdonsize = petscale

        inst:AddComponent("eater")
        inst.components.eater:SetDiet(diet, diet)
        inst.components.eater:SetOnEatFn(oneat)

        inst:AddComponent("perishable")
        inst.components.perishable:SetPerishTime(TUNING.CRITTER_HUNGERTIME)
        inst.components.perishable:StartPerishing()

        inst:AddComponent("locomotor")
        inst.components.locomotor:EnableGroundSpeedMultiplier(not flying)
        inst.components.locomotor:SetTriggersCreep(false)
        inst.components.locomotor.softstop = true
        inst.components.locomotor.walkspeed = TUNING.CRITTER_WALK_SPEED

        inst:AddComponent("crittertraits")
        inst:AddComponent("timer")

        inst:SetBrain(PET_BRAIN)
        inst:SetStateGraph(PET_SG)

        inst.OnSave = OnSave
        inst.OnLoad = OnLoad

        return inst
    end

    return Prefab(name, fn, animszip)
end

-------------------------------------------------------------------------------
local function builder_onbuiltdon(inst, builder)
    local theta = math.random() * 2 * PI
    local pt = builder:GetPosition()
    local radius = 1
    local offset = FindWalkableOffset(pt, theta, radius, 6, true)
    if offset ~= nil then
        pt.x = pt.x + offset.x
        pt.z = pt.z + offset.z
    end
    builder.components.petleash:SpawnPetAt(pt.x, 0, pt.z, inst.pettype, inst.skin_name)
    inst:Remove()
end

local function MakeDonPetBuilder(prefab)
    local function fn()
        local inst = CreateEntity()

        inst.entity:AddTransform()

        inst:AddTag("CLASSIFIED")

        inst.persists = false

        inst:DoTaskInTime(0, inst.Remove)

        if not TheWorld.ismastersim then
            return inst
        end

        inst.pettype = prefab
        inst.OnBuiltFn = builder_onbuiltdon

        return inst
    end

    return Prefab(prefab.."_builder", fn, nil, { prefab })
end

-------------------------------------------------------------------------------

local standard_diet = { FOODGROUP.OMNI }

return MakeDonPet("petdonbabydoydoy", babydoydoyname, 4, "walkbounce2", 1, standard_diet, false, babydoydoyanimzip, babydoydoyconfiganim, babydoydoyanims, babydoydoysounds, {favoritefood="seeds"}),
       MakeDonPetBuilder("petdonbabydoydoy"),
	   
	   MakeDonPet("petdonstungray", stungrayname, 4, "walkfly2", 1, standard_diet, true, stungrayanimzip, stungrayconfiganim, stungrayanims, stungraysounds, {favoritefood="fish"}),
       MakeDonPetBuilder("petdonstungray"),
	   
	   MakeDonPet("petdoncrabbit", crabbitname, 4, "walk", 1, standard_diet, false, crabbitanimzip, crabbitconfiganim, crabbitanims, crabbitsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdoncrabbit"),
	   
	   MakeDonPet("petdondogfish", dogfishname, 4, "walk", 0.8, standard_diet, false, dogfishanimzip, dogfishconfiganim, dogfishanims, dogfishsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdondogfish"),
	   
	   MakeDonPet("petdonflup", flupname, 4, "walk", 1, standard_diet, false, flupanimzip, flupconfiganim, flupanims, flupsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdonflup"),
	   
	   MakeDonPet("petdonpackim", packimname, 6, "walkfly1", 1, standard_diet, true, packimanimzip, packimconfiganim, packimanims, packimsounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdonpackim"),
	   
	   MakeDonPet("petdonsharkitten", sharkittenname, 4, "walkbounce", 0.8, standard_diet, false, sharkittenanimzip, sharkittenconfiganim, sharkittenanims, sharkittensounds, {favoritefood="meat"}),
	   MakeDonPetBuilder("petdonsharkitten"),
	   
	   MakeDonPet("petdonswordfish", swordfishname, 4, "walk", 0.7, standard_diet, false, swordfishanimzip, swordfishconfiganim, swordfishanims, swordfishsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdonswordfish"),
	   
	   MakeDonPet("petdonsharx", sharxname, 4, "walk", 0.7, standard_diet, false, sharxanimzip, sharxconfiganim, sharxanims, sharxsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdonsharx"),
	   
	   MakeDonPet("petdonprimeape", primeapename, 6, "walk", 0.9, standard_diet, false, primeapeanimzip, primeapeconfiganim, primeapeanims, primeapesounds, {favoritefood="cave_banana"}),
	   MakeDonPetBuilder("petdonprimeape"),
	   
	   MakeDonPet("petdonpirateghost", pirateghostname, 4, "walk", 0.6, standard_diet, true, pirateghostanimzip, pirateghostconfiganim, pirateghostanims, pirateghostsounds, {favoritefood="petals_evil"}),
	   MakeDonPetBuilder("petdonpirateghost"),
	   
	   --V0.2:
	   MakeDonPet("petdonmossling", mosslingname, 4, "walk", 0.7, standard_diet, false, mosslinganimzip, mosslingconfiganim, mosslinganims, mosslingsounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdonmossling"),
	   
	   MakeDonPet("petdonpenguin", penguinname, 4, "walk", 0.9, standard_diet, false, penguinanimzip, penguinconfiganim, penguinanims, penguinsounds, {favoritefood="fish"}),
	   MakeDonPetBuilder("petdonpenguin"),
	   
	   MakeDonPet("petdonlightninggoat", lightninggoatname, 4, "walkbounce2", 0.7, standard_diet, false, lightninggoatanimzip, lightninggoatconfiganim, lightninggoatanims, lightninggoatsounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdonlightninggoat"),
	   
	   MakeDonPet("petdondeer", deername, 6, "walk", 0.7, standard_diet, false, deeranimzip, deerconfiganim, deeranims, deersounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdondeer"),
	   	   
	   MakeDonPet("petdonbat", batname, 4, "walkfly2", 0.8, standard_diet, true, batanimzip, batconfiganim, batanims, batsounds, {favoritefood="monstermeat"}),
       MakeDonPetBuilder("petdonbat"),
	   
	   MakeDonPet("petdonspider", spidername, 4, "walkfly2", 0.7, standard_diet, false, spideranimzip, spiderconfiganim, spideranims, spidersounds, {favoritefood="monstermeat"}),
	   MakeDonPetBuilder("petdonspider"),
	   
	   MakeDonPet("petdonbee", beename, 4, "flybuzz", 1.1, standard_diet, true, beeanimzip, beeconfiganim, beeanims, beesounds, {favoritefood="flower"}),
	   MakeDonPetBuilder("petdonbee"),
	   
	   MakeDonPet("petdonmosquito", mosquitoname, 4, "flybuzz", 1.1, standard_diet, true, mosquitoanimzip, mosquitoconfiganim, mosquitoanims, mosquitosounds, {favoritefood="monstermeat"}),
	   MakeDonPetBuilder("petdonmosquito"),
   
	   MakeDonPet("petdonminiwilson", miniwilsonname, 4, "walk", 0.5, standard_diet, false, miniwilsonanimzip, miniwilsonconfiganim, miniwilsonanims, miniwilsonsounds, {favoritefood="carrot"}),
       MakeDonPetBuilder("petdonminiwilson"),
	   
	   --V0.3:	   
	   MakeDonPet("petdonbirchnutdrake", birchnutdrakename, 4, "walkbounce2", 1, standard_diet, false, birchnutdrakeanimzip, birchnutdrakeconfiganim, birchnutdrakeanims, birchnutdrakesounds, {favoritefood="seeds"}),
	   MakeDonPetBuilder("petdonbirchnutdrake"),
	   
	   MakeDonPet("petdonmandrake", mandrakename, 4, "walkbounce2", 1, standard_diet, false, mandrakeanimzip, mandrakeconfiganim, mandrakeanims, mandrakesounds, {favoritefood="berries"}),
	   MakeDonPetBuilder("petdonmandrake"),
	   
	   MakeDonPet("petdonbunnyman", bunnymanname, 4, "walkbounce2", 0.55, standard_diet, false, bunnymananimzip, bunnymanconfiganim, bunnymananims, bunnymansounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdonbunnyman"),
	   
	   MakeDonPet("petdonbeeguard", beeguardname, 6, "flybuzz", 1, standard_diet, true, beeguardanimzip, beeguardconfiganim, beeguardanims, beeguardsounds, {favoritefood="honey"}),
	   MakeDonPetBuilder("petdonbeeguard"),
	   
	   MakeDonPet("petdongrassgekko", grassgekkoname, 4, "walk", 0.93, standard_diet, false, grassgekkoanimzip, grassgekkoconfiganim, grassgekkoanims, grassgekkosounds, {favoritefood="carrot"}),
	   MakeDonPetBuilder("petdongrassgekko")
       	   